#ifndef THING_H
#define THING_H

#include <list>
#include "manager.h"
#include "command.h"

/*
  Die meisten oder besser fast alle Dinge im Spiel sind von einem Typ der von Thing abgeleitet ist.
*/

class Thing
{
public:
    Thing(int id);
    virtual void execute(Instruction * pInst); //Im gegensatz zum Manager werden einfache Things nie Listen sonden immer nur
    //einzelne Kommandos erhalten. In der Regel kommen diese direkt vom Manager. D.h. der Manager erhlt eine liste
    //von Commands die er der Reihe nach an die einzelnen Things weitergibt.
    static void setManager(Manager &manager);
    virtual void execute(Command::Word cmd);

private:

    static Manager * manager; //Es gibt nur einen einzigen Manager (Ein singelton also) im ganzen Programm)
    int id; //Jedes Object im Spiel hat eine eindeutige id, anhand der es vom Managerobjekt verwaltet wird.

    //function not suposed to be called by this::execute();
    void command(std::list<Instruction> * instructions); //Ruft im Grunde nur manager.command() mit der bergebenen Liste an commands auf.

    //functions which can be called by this::execute();
    //Einige davon werden erst von den Klassen die von Thing abgeleitet werden deklariert und auch implementiert. Thing
    //ruft diese dann auf.
    //Andere sind fr alle Klassen die in von Thing ableiten erreichbar.
};

#endif // THING_H
